include masm32rt.inc
.686p
.mmx
.xmm

WndProc proto hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

.data?
	hInstance	dd ?
.code
main proc 
LOCAL wcex:WNDCLASSEX
LOCAL msg:MSG

	mov hInstance,rv(GetModuleHandle,0)
	mov wcex.hInstance,eax
	mov wcex.cbSize,SIZEOF WNDCLASSEX
	mov wcex.style, CS_HREDRAW or CS_VREDRAW
	mov wcex.lpfnWndProc, OFFSET WndProc
	mov wcex.cbClsExtra,NULL
	mov wcex.cbWndExtra,0
	mov wcex.hbrBackground,rv(GetStockObject,WHITE_BRUSH)
	mov wcex.lpszMenuName,NULL
	mov wcex.lpszClassName,chr$("win32class")
	mov wcex.hIcon,rv(LoadIcon,NULL,IDI_APPLICATION)
	mov wcex.hIconSm,eax
	mov wcex.hCursor,rv(LoadCursor,NULL,IDC_ARROW)
	invoke RegisterClassEx, ADDR wcex
	mov esi,rv(CreateWindowEx,0,wcex.lpszClassName,"Win32App",WS_VISIBLE or WS_SYSMENU or WS_SIZEBOX or WS_MINIMIZEBOX or WS_MAXIMIZEBOX or WS_CLIPCHILDREN,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,0,0,hInstance,0)

	.while 1
		invoke GetMessage,ADDR msg,NULL,0,0
		.break .if !eax || eax == -1
		invoke TranslateMessage, ADDR msg
		invoke DispatchMessage, ADDR msg
	.endw

	invoke ExitProcess,msg.wParam

main endp

WndProc proc uses ebx esi edi hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
LOCAL ps:PAINTSTRUCT
LOCAL char:CHAR
LOCAL rect:RECT

	.if uMsg == WM_CLOSE
		invoke PostQuitMessage,NULL
	.elseif uMsg == WM_DESTROY
	.elseif uMsg == WM_CREATE
		
	.elseif uMsg  == WM_PAINT
		mov ebx,rv(BeginPaint,hWnd,ADDR ps)

		invoke MoveToEx,ebx,0,0,0
		xor esi,esi
		xor edi,edi
		.while esi <= 16
			invoke LineTo,ebx,16*20,edi
			lea edi,[edi+20]
			invoke MoveToEx,ebx,0,edi,0
			lea esi,[esi+1]
		.endw
		
		invoke MoveToEx,ebx,0,0,0
		xor esi,esi
		xor edi,edi
		.while esi <= 16
			invoke LineTo,ebx,edi,16*20
			lea edi,[edi+20]
			invoke MoveToEx,ebx,edi,0,0
			lea esi,[esi+1]
		.endw		
		
		xor ebx,ebx
		xor edi,edi
		.while edi < 16*20
			xor esi,esi
			.while esi < 16*20
				mov char,bl
				mov rect.left,esi
				mov rect.top,edi
				mov rect.right,esi
				mov rect.bottom,edi
				add rect.right,20
				add rect.bottom,20
				invoke DrawText,ps.hdc,ADDR char,1,ADDR rect,DT_VCENTER or DT_SINGLELINE or DT_CENTER
				lea ebx,[ebx+1]
				lea esi,[esi+20]
			.endw
			lea edi,[edi+20]
		.endw
		
		invoke EndPaint,hWnd,ADDR ps		
	.else
		invoke DefWindowProc,hWnd,uMsg,wParam,lParam
		ret
	.endif

	xor eax,eax
	ret
WndProc endp
end main
